//////////////////////////////////////////////////////////////////////////////
//
// FirstOrderDataDependentPatch_bending.cpp, 05/19/02, Ilja Friedel
//
//////////////////////////////////////////////////////////////////////////////

#include "FirstOrderDataDependentPatch.h"

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//#define DATA_DEPENDEND_KP_DERIVATIVES
#define CENTRAL_DIFF_GRAD_FOR_HESS_KPENERGY_CENTRAL_DIFF_def

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

int FirstOrderDataDependentPatch::load_Kp(void)
{
  int  i,j,xxx;
  FILE *f;
  char fname[256];

  for(xxx=0;xxx<6;xxx++)
    {
      FODD_Kp[xxx][Valence]=new double[M*M];
      assert(FODD_Kp[xxx][Valence]);
    }

  for(xxx=0;xxx<6;xxx++)
    {
      if(xxx==0) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EE.mtx",Valence);
      if(xxx==1) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EF.mtx",Valence);
      if(xxx==2) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EG.mtx",Valence);
      if(xxx==3) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_FF.mtx",Valence);
      if(xxx==4) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_FG.mtx",Valence);
      if(xxx==5) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_GG.mtx",Valence);
      
      f=fopen(fname,"r");
      if(!f)
	{
	  return(0);
	}
      
      for(i=0;i<M;i++)
	{
	  for(j=0;j<M;j++)
	    {
	      fscanf(f,"%lf",&(FODD_Kp[xxx][Valence][i*M+j]));
	    }
	  fscanf(f,"\n");
	}
      fclose(f);
    }
  return(1);
}

//////////////////////////////////////////////////////////////////////////////

void FirstOrderDataDependentPatch::save_Kp(void)
{
  int i,j,xxx;
  FILE *f;
  char fname[256];

  for(xxx=0;xxx<6;xxx++)
    {
      if(xxx==0) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EE.mtx",Valence);
      if(xxx==1) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EF.mtx",Valence);
      if(xxx==2) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_EG.mtx",Valence);
      if(xxx==3) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_FF.mtx",Valence);
      if(xxx==4) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_FG.mtx",Valence);
      if(xxx==5) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Kp/FODD_Valence_%d_Kp_GG.mtx",Valence);

      f=fopen(fname,"w");
      for(i=0;i<M;i++)
	{
	  for(j=0;j<M;j++)
	    {
	      fprintf(f,"%1.18e\t",FODD_Kp[xxx][Valence][i*M+j]);
	    }
	  fprintf(f,"\n");
	}
      fclose(f);
    }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

double FirstOrderDataDependentPatch::Kp_function(const double u1, const double u2)
{
  double u,v;

  u=u1;
  v=u2;

  assert(u>=0.0 && u<=1.0);
  assert(v>=0.0 && v<=1.0);

  //double X,Y,Z;

  double d1Ch1, d2Ch1;
  double d1Ch2, d2Ch2;

  double d1d1Ch1, d1d1Ch2; 
  double d1d2Ch1, d1d2Ch2;
  double d2d2Ch1, d2d2Ch2;

  double d1hi, d2hi;
  double d1hj, d2hj;

  double d1d1hi, d1d2hi, d2d2hi;
  double d1d1hj, d1d2hj, d2d2hj;

  double result;

  // the characteristic map is the reference surface

  d1Ch1  = ES->evaluate_D1phi(u,v,1);
  d2Ch1  = ES->evaluate_D2phi(u,v,1);
  d1d1Ch1= ES->evaluate_D1D1phi(u,v,1);
  d1d2Ch1= ES->evaluate_D1D2phi(u,v,1);
  d2d2Ch1= ES->evaluate_D2D2phi(u,v,1);

  d1Ch2  = ES->evaluate_D1phi(u,v,2);
  d2Ch2  = ES->evaluate_D2phi(u,v,2);
  d1d1Ch2= ES->evaluate_D1D1phi(u,v,2);
  d1d2Ch2= ES->evaluate_D1D2phi(u,v,2);
  d2d2Ch2= ES->evaluate_D2D2phi(u,v,2);

  // the derivatives of the i'th eigenfunction

  d1hi   = ES->evaluate_D1phi(  u,v,IL_i);
  d2hi   = ES->evaluate_D2phi(  u,v,IL_i);
  d1d1hi = ES->evaluate_D1D1phi(u,v,IL_i);
  d1d2hi = ES->evaluate_D1D2phi(u,v,IL_i);
  d2d2hi = ES->evaluate_D2D2phi(u,v,IL_i);

  // the derivatives of the j'th eigenfunction

  d1hj   = ES->evaluate_D1phi(  u,v,IL_j);
  d2hj   = ES->evaluate_D2phi(  u,v,IL_j);
  d1d1hj = ES->evaluate_D1D1phi(u,v,IL_j);
  d1d2hj = ES->evaluate_D1D2phi(u,v,IL_j);
  d2d2hj = ES->evaluate_D2D2phi(u,v,IL_j);

  // compute integrand with Maple's formula
  if(xxxx==0)      // K_EE
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cEE.c"
    }
  else if(xxxx==1) // K_EF
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cEF.c"
    }
  else if(xxxx==2) // K_EG
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cEG.c"
    }
  else if(xxxx==3) // K_FF
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cFF.c"
    }
  else if(xxxx==4) // K_FG
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cFG.c"
    }
  else if(xxxx==5) // K_GG
    {
#include "data/FirstOrderDataDependentFormulas/bending/include/cGG.c"
    }
  else
    {
      cerr << "Error: No valid xxxx set in FODDP::Kp_function."
	   << "Please specify which matrix to compute."
	   << endl;
      exit(1);
    }

  // scale result:  ------ denominator -------         ------- Jacobian -------
  result=(result/pow(d1Ch1*d2Ch2-d2Ch1*d1Ch2,6.0)) * fabs(d1Ch1*d2Ch2-d2Ch1*d1Ch2);

  return(result);
}

//////////////////////////////////////////////////////////////////////////////

void FirstOrderDataDependentPatch::Kp(Patch *S, double *K)
{
  int    i, j, k;
  double t;
  double *tmp;
  double E,F,G;

  assert(S==NULL);

  if(!FODD_Kp[0][Valence])
    if(!load_Kp())
      {
	// compute the matrices and save them to disc
	tmp=new double[M*M];

	for(xxxx=0;xxxx<6;xxxx++)
	  {
	    for(IL_i=0;IL_i<M;IL_i++)
	      {
		for(IL_j=IL_i;IL_j<M;IL_j++)
		  {
		    double tmp_I;

		    if(IL_i==0||IL_j==0||
		       IL_i==1||IL_j==1||
		       IL_i==2||IL_j==2) tmp_I=0.0;
		    else
		      {
			double lambda_i, lambda_j, lambda;
			
			//tmp_I=Integrate((F2D)&FirstOrderDataDependentPatch::Kp_function,
			//	    0.0,1.0, 0.0,1.0);
			
			tmp_I =Integrate((F2D)&FirstOrderDataDependentPatch::Kp_function,
					0.5,1.0, 0.5,1.0);

			tmp_I+=Integrate((F2D)&FirstOrderDataDependentPatch::Kp_function,
					0.0,0.5, 0.5,1.0);

			tmp_I+=Integrate((F2D)&FirstOrderDataDependentPatch::Kp_function,
					0.5,1.0, 0.0,0.5);
			
			lambda_i=Lambda[Valence][IL_i*M+IL_i];
			lambda_j=Lambda[Valence][IL_j*M+IL_j];
			lambda  =Lambda[Valence][   1*M+   1]; // subdominant lambda

			tmp_I=tmp_I/(1.0-lambda_i*lambda_j/(lambda*lambda));
			
		      }
		    K[M*IL_j+IL_i]=tmp_I;
		    K[M*IL_i+IL_j]=tmp_I;
		    
		    cout<<".";
		    fflush(0);
		  }
		cout<<endl;
	      }
	    
	    FODD_Kp[xx][Valence]=new double[M*M];
	    assert(FODD_Kp[xx][Valence]);

	    // K=mult(transpose(iX)*K*iX);
	    ///* ********************************************************
	    for(i=0;i<M;++i)
	      {
		for(k=0;k<M;++k) 
		  {
		    t=0.0;
		    for(j=0;j<M;++j )
		      {
			t+=K[i*M+j]*iX[Valence][j*M+k];
		      }
		    tmp[i*M+k]=t;
		  }
	      }
	    for(i=0;i<M;++i)
	      {
		for(k=0;k<M;++k) 
		  {
		    t=0.0;
		    for(j=0;j<M;++j )
		      {
			t+=iX[Valence][j*M+i]*tmp[j*M+k];
		      } //             ^^^^^ j and i transposed
		    FODD_Kp[xxxx][Valence][i*M+k]=t;
		  }
	      }
  //*/
	    //for(i=0;i<M*M;++i) FODD_Kp[xxxx][Valence][i]=K[i];;

	    save_Kp(); // *** moved into loop ***
	  }
	delete[] tmp;
      }

  // ************************************************************************
  // ************************************************************************
  // ************************************************************************
  // ************************************************************************
  // ************************************************************************
  // to do (check E and G)

  double u11, u21, u31;
  double u12, u22, u32;

  if(Valence!=4)
    {
      u11=ES->eigen_controlpoints[0][1];
      u21=ES->eigen_controlpoints[1][1];
      u31=ES->eigen_controlpoints[2][1];
      u12=ES->eigen_controlpoints[0][2];
      u22=ES->eigen_controlpoints[1][2];
      u32=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u11=0.0;
      u21=0.0;
      u31=0.0;
      u12=0.0;
      u22=0.0;
      u32=0.0;
      
      for(i=0;i<16;i++)
	{	  
	  u11+=VdS4[0][i]*control_points[0][i];
	  u21+=VdS4[0][i]*control_points[1][i];
	  u31+=VdS4[0][i]*control_points[2][i];
	  u12+=VdS4[1][i]*control_points[0][i];
	  u22+=VdS4[1][i]*control_points[1][i];
	  u32+=VdS4[1][i]*control_points[2][i];
	}
    }

  E = u11*u11 + u21*u21 + u31*u31;
  F = u11*u12 + u21*u22 + u31*u32;
  G = u12*u12 + u22*u22 + u32*u32;
  /*
  E = 1.0;
  F = 0.0;
  G = 1.0;
 
  //cerr << "E=1,F=0,G=1";
  */

  double EGFF_EE,EGFF_EF,EGFF_EG,EGFF_FF,EGFF_FG,EGFF_GG,EGFF;

  EGFF=pow(E*G-F*F,-1.5);
  EGFF_EE=EGFF*E*E;
  EGFF_EF=EGFF*E*F;
  EGFF_EG=EGFF*E*G;
  EGFF_FF=EGFF*F*F;
  EGFF_FG=EGFF*F*G;
  EGFF_GG=EGFF*G*G;

  for(i=0;i<M;i++)
    {
      for(j=i;j<M;j++)
	{  
	  double tmp;
	  tmp = EGFF_EE * FODD_Kp[0][Valence][i*M+j] + 
	        EGFF_EF * FODD_Kp[1][Valence][i*M+j] +
	        EGFF_EG * FODD_Kp[2][Valence][i*M+j] +
	        EGFF_FF * FODD_Kp[3][Valence][i*M+j] +
	        EGFF_FG * FODD_Kp[4][Valence][i*M+j] +
	        EGFF_GG * FODD_Kp[5][Valence][i*M+j];
	  K[i*M+j]= tmp;
	  K[j*M+i]= tmp;
	}
    }

	  /*	  
  for(i=0;i<M*M;i++) K[i] = EGFF_EE * FODD_Kp[0][Valence][i] + 
			    EGFF_EF * FODD_Kp[1][Valence][i] +
			    EGFF_EG * FODD_Kp[2][Valence][i] +
			    EGFF_FF * FODD_Kp[3][Valence][i] +
			    EGFF_FG * FODD_Kp[4][Valence][i] +
			    EGFF_GG * FODD_Kp[5][Valence][i];
	  */
  // alternativly (this is slower)
  /*
  for(i=0;i<M*M;i++) K[i] = EGFF_EE * FODD_Kp[0][Valence][i];
  for(i=0;i<M*M;i++) K[i]+= EGFF_EF * FODD_Kp[1][Valence][i];
  for(i=0;i<M*M;i++) K[i]+= EGFF_EG * FODD_Kp[2][Valence][i];
  for(i=0;i<M*M;i++) K[i]+= EGFF_FF * FODD_Kp[3][Valence][i];
  for(i=0;i<M*M;i++) K[i]+= EGFF_FG * FODD_Kp[4][Valence][i];
  for(i=0;i<M*M;i++) K[i]+= EGFF_GG * FODD_Kp[5][Valence][i];
  */

      /*
      //matrix([[1/(X^2)+Y^2/X^2/Z^2, -Y/X/Z^2], [-Y/X/Z^2, 1/(Z^2)]])
      E = (Z*Z + Y*Y)/(X*X * Z*Z);
      F =       -Y*X /(X*X * Z*Z);
      G =        X*X /(X*X * Z*Z);
      
      //cout << "X="<<X<<", Y="<<Y<<", Z="<<Z<<endl;
      //cout << "E="<<E<<", F="<<F<<", G="<<G<<endl;
      
      for(i=0;i<M*M;i++) K[i] = fabs(X*Z) * (E*E * FODD_Kp[0][Valence][i] + 
					     E*F * FODD_Kp[1][Valence][i] +
					     E*G * FODD_Kp[2][Valence][i] +
					     F*F * FODD_Kp[3][Valence][i] +
					     F*G * FODD_Kp[4][Valence][i] +
					     G*G * FODD_Kp[5][Valence][i]);
      */
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// this function is for debugging only

void FirstOrderDataDependentPatch::save_bending_integrands(int mode_i, int mode_j, int coeff)
{
  int N,M;
  int i,j;
  char fn[256];
  
  FILE *f;

  IL_i=mode_i;
  IL_j=mode_j;
  xxxx=coeff;

  cout << "IL_i="<<IL_i<<", IL_j="<<IL_j<<", xxxx="<<xxxx<<endl;

  assert(IL_i<Valence*2+8);
  assert(IL_j<Valence*2+8);
  assert(xxxx<9);

  sprintf(fn,"KpInt_Valence%d_Coeff%d_mode%d_mode%d.iv",Valence,coeff,mode_i,mode_j);

  N=10;
  M=10;

  f=fopen(fn,"w");
  assert(f);
  
  fprintf(f,"#Inventor V2.0 ascii\n\n");
  fprintf(f,"Separator {\n");
  fprintf(f,"	LightModel\n");
  fprintf(f,"	{\n");
  fprintf(f,"	   #model BASE_COLOR\n");
  fprintf(f,"	}\n");
  fprintf(f,"	ShapeHints {\n");
  fprintf(f,"	shapeType UNKNOWN_SHAPE_TYPE\n");
  fprintf(f,"	vertexOrdering	COUNTERCLOCKWISE\n");
  fprintf(f,"	}\n");

  fprintf(f,"    Coordinate3 {\n");
  fprintf(f,"	point	[\n");

  for(i=0;i<=N;i++)
    {
      for(j=0;j<=M;j++)
	{
	  if(i==N && j==M)
	    {
	      fprintf(f,"         %e %e %e",
		      (i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1),
		      Kp_function((i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1)));
	    }
	  else
	    {
	      fprintf(f,"         %e %e %e,",
		      (i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1),
		      Kp_function((i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1)));
	    }
	  fprintf(f,"\n");
	}
    }

  fprintf(f,"    ]}\n");
  fprintf(f,"    QuadMesh {\n");
  fprintf(f,"	verticesPerColumn	%d\n",N+1);
  fprintf(f,"	verticesPerRow	%d\n",M+1);
  fprintf(f,"    }\n");
  fprintf(f,"}\n");

  fclose(f);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// compute Kp matrix and from that get the energy approximation

double FirstOrderDataDependentPatch::KpEnergy(void)
{
  double *K;
  double E;
  int i,j;

  E=0.0;
  
  K=new double[M*M];
  Kp(NULL,K);

  for(i=0;i<M;i++)
    {
      for(j=i+1;j<M;j++)
	{
	  E=E+K[(M)*i+j]*
	    (control_points[0][i]*control_points[0][j]+
	     control_points[1][i]*control_points[1][j]+
	     control_points[2][i]*control_points[2][j]);
	}
    }
  E=E*2.0;
  for(i=0;i<M;i++)
     {
       E=E+K[(M)*i+i]*
	    (control_points[0][i]*control_points[0][i]+
	     control_points[1][i]*control_points[1][i]+
	     control_points[2][i]*control_points[2][i]);
     }
  delete[] K;

  return E;
}

//////////////////////////////////////////////////////////////////////////////
// function mostly for debugging purposes

void FirstOrderDataDependentPatch::grad_KpEnergy_central_diff(double *G)
{
  FirstOrderDataDependentPatch *FP1;
  FirstOrderDataDependentPatch *FP2;
  double diff,tmp;
  int i, coord;

  for(i=0;i<M;i++)
    {
      for(coord=0;coord<3;coord++)
	{

	  tmp=control_points[coord][i];

	  control_points[coord][i]=tmp+EPSILON2;
	  FP1=new FirstOrderDataDependentPatch(control_points, Valence);
	  control_points[coord][i]=tmp-EPSILON2;
	  FP2=new FirstOrderDataDependentPatch(control_points, Valence);

	  diff=(FP1->KpEnergy() - FP2->KpEnergy())/(2.0*EPSILON2);
	  //diff=(FP1->ExactBendingEnergy() - FP2->ExactBendingEnergy())/(2.0*EPSILON2);
	  
	  delete(FP1);
	  delete(FP2);
	  control_points[coord][i]=tmp;
	  
	  G[3*i+coord]=diff;
	}
    }
}

//////////////////////////////////////////////////////////////////////////////
// function mostly for debugging purposes

void FirstOrderDataDependentPatch::Hess_KpEnergy_central_diff(double *Hess)
{
  int    i,j,k;
  double diff;
  FirstOrderDataDependentPatch *FP11, *FP12;

  for(i=0;i<9*M*M;i++)
    {
      Hess[i] = 0.0;
    }

#ifdef CENTRAL_DIFF_GRAD_FOR_HESS_KPENERGY_CENTRAL_DIFF_def
  // **********************************************************************************
  // pure central differences
  // **********************************************************************************
  double tmp1,tmp2;
  double diff1,diff2;
  int l;
  FirstOrderDataDependentPatch *FP21, *FP22;

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      for(l=0;l<3;l++)
		{
		  tmp1=control_points[k][i];
		  tmp2=control_points[l][j];

		  if(i==j && k==l)
		    {
		      FP22=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1+EPSILON3;
		      FP11=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      FP12=new FirstOrderDataDependentPatch(control_points, Valence);
		      
		      diff=(FP11->KpEnergy() + FP12->KpEnergy() - 2.0*FP22->KpEnergy()); 

		      diff=diff/(EPSILON3*EPSILON3);
		    }
		  else
		    {
		      control_points[k][i]=tmp1+EPSILON3;
		      control_points[l][j]=tmp2+EPSILON3;
		      FP11=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1+EPSILON3;
		      control_points[l][j]=tmp2-EPSILON3;
		      FP12=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      control_points[l][j]=tmp2+EPSILON3;
		      FP21=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      control_points[l][j]=tmp2-EPSILON3;
		      FP22=new FirstOrderDataDependentPatch(control_points, Valence);
		      
		      diff1=(FP11->KpEnergy() - FP12->KpEnergy())/(2.0*EPSILON3);
		      diff2=(FP21->KpEnergy() - FP22->KpEnergy())/(2.0*EPSILON3);
		      diff=(diff1-diff2)/(2.0*EPSILON3);
		    }

		  Hess[3*M*(3*j+l)+(3*i+k)]+=0.5*diff;
		  Hess[3*M*(3*i+k)+(3*j+l)]+=0.5*diff;

		  delete(FP11);
		  delete(FP12);
		  if(!(i==j && k==l))
		    {
		      delete(FP21);
		    }
		  delete(FP22);
		  control_points[k][i]=tmp1;
		  control_points[l][j]=tmp2;
		}
	    }
	}
    }
#else
  // **********************************************************************************
  // central differences of Kp gradient (which we hope works) is used
  // **********************************************************************************

  double *G1;
  double *G2;
  double tmp;

  G1=new double[3*M];
  G2=new double[3*M];

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  tmp=control_points[k][i];

	  control_points[k][i]=tmp+EPSILON2;
	  FP11=new FirstOrderDataDependentPatch(control_points, Valence);

	  control_points[k][i]=tmp-EPSILON2;
	  FP12=new FirstOrderDataDependentPatch(control_points, Valence);
	  control_points[k][i]=tmp;

	  FP11->grad_KpEnergy(G1);
	  FP12->grad_KpEnergy(G2);

	  for(j=0;j<3*M;j++)
	    {
	      diff=(G1[j] - G2[j])/(2.0*EPSILON2);
	      Hess[3*M*(  j  )+(3*i+k)]+=0.5*diff;
	      Hess[3*M*(3*i+k)+(  j  )]+=0.5*diff;	     
	    }
	  
	  delete(FP11);
	  delete(FP12);
	}
    }
  delete[] G1;
  delete[] G2;

#endif
}

//////////////////////////////////////////////////////////////////////////////
// working
// ************************************************************************
// ************************************************************************
// ************************************************************************
// ************************************************************************
// ************************************************************************
// can we make it faster?

void FirstOrderDataDependentPatch::grad_KpEnergy(double *grad)
{
  int i,j,k;

#ifdef DATA_DEPENDEND_KP_DERIVATIVES
  if(!FODD_Kp[0][Valence])
    if(!load_Kp())
      {
	cerr << "Error: Can't load energy matrices!"<<endl;
	cerr << "       Call Kp first to compute them."<< endl;
	cerr << "[void FirstOrderDataDependentPatch::grad_KpEnergy(double *G)]"<< endl;
	exit(1);
      }

  double u[3][2];
  double **v;
  v=new double*[2];
  v[0]=new double[M];
  v[1]=new double[M];

  double E, F, G;
  double *DE;
  double *DF;
  double *DG;
  DE=new double[3*M];
  DF=new double[3*M];
  DG=new double[3*M];
  double eEE, eEF, eEG, eFF, eFG, eGG;
  double *DeEE;
  double *DeEF;
  double *DeEG;
  double *DeFF;
  double *DeFG;
  double *DeGG;
  DeEE=new double[3*M];
  DeEF=new double[3*M];
  DeEG=new double[3*M];
  DeFF=new double[3*M];
  DeFG=new double[3*M];
  DeGG=new double[3*M];

  // copy the subdominant eigenvectors
   if(Valence!=4)
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=iX[Valence][1*M+i];
	  v[1][i]=iX[Valence][2*M+i];  // ??????????? order ????????????
	}
    }
  else
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=VdS4[0][i];
	  v[1][i]=VdS4[1][i];  // ??????????? order ????????????
	}
    }

  // copy the subdominant controlpoints
  if(Valence!=4)
    {
      u[0][0]=ES->eigen_controlpoints[0][1];
      u[1][0]=ES->eigen_controlpoints[1][1];
      u[2][0]=ES->eigen_controlpoints[2][1];
      u[0][1]=ES->eigen_controlpoints[0][2];
      u[1][1]=ES->eigen_controlpoints[1][2];
      u[2][1]=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u[0][0]=0.0;
      u[1][0]=0.0;
      u[2][0]=0.0;
      u[0][1]=0.0;
      u[1][1]=0.0;
      u[2][1]=0.0;
      
      for(i=0;i<16;i++)
	{  
	  u[0][0]+=VdS4[0][i]*control_points[0][i];
	  u[1][0]+=VdS4[0][i]*control_points[1][i];
	  u[2][0]+=VdS4[0][i]*control_points[2][i];
	  u[0][1]+=VdS4[1][i]*control_points[0][i];
	  u[1][1]+=VdS4[1][i]*control_points[1][i];
	  u[2][1]+=VdS4[1][i]*control_points[2][i];
	}
    }

  // compute the three parameters
  E = u[0][0]*u[0][0] + u[1][0]*u[1][0] + u[2][0]*u[2][0];
  F = u[0][0]*u[0][1] + u[1][0]*u[1][1] + u[2][0]*u[2][1];
  G = u[0][1]*u[0][1] + u[1][1]*u[1][1] + u[2][1]*u[2][1];

  //cout << "E="<<E<<", F="<<F<<", G="<<G<<endl;

  // compute the gradients of the parameters
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  DE[3*i+k] = 2.0 * u[k][0] * v[0][i];
	  DF[3*i+k] =       u[k][1] * v[0][i] + 
	                    u[k][0] * v[1][i];
	  DG[3*i+k] = 2.0 * u[k][1] * v[1][i];
	}
    }

  //cout << endl;
      
  // compute the unscaled energies of the 6 quadratic forms
  eEE=0.0;
  eEF=0.0;
  eEG=0.0;
  eFF=0.0;
  eFG=0.0;
  eGG=0.0;
  for(j=0;j<M;j++)
    {
      for(i=0;i<M;i++)
	{
	  double xi, xj;
	  double yi, yj;
	  double zi, zj;
	  double tmp;
	  
	  xi=control_points[0][i]; xj=control_points[0][j];
	  yi=control_points[1][i]; yj=control_points[1][j];
	  zi=control_points[2][i]; zj=control_points[2][j];

	  tmp=xi*xj + yi*yj + zi*zj;

	  eEE += FODD_Kp[0][Valence][M*j+i]*tmp;  
	  eEF += FODD_Kp[1][Valence][M*j+i]*tmp;
	  eEG += FODD_Kp[2][Valence][M*j+i]*tmp;
	  eFF += FODD_Kp[3][Valence][M*j+i]*tmp;
	  eFG += FODD_Kp[4][Valence][M*j+i]*tmp;
	  eGG += FODD_Kp[5][Valence][M*j+i]*tmp;
	}
    }

  // compute the gradients of the quadratic forms, which is part of the new grad
  for(i=0;i<3*M;i++)
    {
      DeEE[i]=0.0;
      DeEF[i]=0.0;
      DeEG[i]=0.0;
      DeFF[i]=0.0;
      DeFG[i]=0.0;
      DeGG[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  for(j=0;j<M;j++)
	    {
	      tmp = control_points[k][j];
	      DeEE[3*i+k] += 2.0 * FODD_Kp[0][Valence][M*i+j]*tmp;  
	      DeEF[3*i+k] += 2.0 * FODD_Kp[1][Valence][M*i+j]*tmp;
	      DeEG[3*i+k] += 2.0 * FODD_Kp[2][Valence][M*i+j]*tmp;
	      DeFF[3*i+k] += 2.0 * FODD_Kp[3][Valence][M*i+j]*tmp;
	      DeFG[3*i+k] += 2.0 * FODD_Kp[4][Valence][M*i+j]*tmp;
	      DeGG[3*i+k] += 2.0 * FODD_Kp[5][Valence][M*i+j]*tmp;
	    }
	}
    }
	  
  // compute and add the correction factor to get the gradient of the energy
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  double DcEE, DcEF, DcEG;
	  double DcFF, DcFG, DcGG;
	  double D_EGFF,EGFF;

	  EGFF   = pow(E*G-F*F,-1.5);  // **** put out of loop
	  D_EGFF = -1.5*pow(E*G-F*F,-2.5)*(DE[3*i+k]*G + E*DG[3*i+k] - 2.0*F*DF[3*i+k]);

	  DcEE = E*E*D_EGFF +          2.0 * E*DE[3*i+k] *EGFF;
	  DcFF = F*F*D_EGFF +          2.0 * F*DF[3*i+k] *EGFF;
	  DcGG = G*G*D_EGFF +          2.0 * G*DG[3*i+k] *EGFF;
	  DcEF = E*F*D_EGFF + (E*DF[3*i+k] + F*DE[3*i+k])*EGFF;
	  DcEG = E*G*D_EGFF + (E*DG[3*i+k] + G*DE[3*i+k])*EGFF;
	  DcFG = F*G*D_EGFF + (F*DG[3*i+k] + G*DF[3*i+k])*EGFF;

	  grad[3*i+k] = eEE * DcEE +
	                eEF * DcEF +
	                eEG * DcEG +
	                eFF * DcFF +
	                eFG * DcFG +
	                eGG * DcGG + EGFF*(E*E*DeEE[3*i+k]+
					   E*F*DeEF[3*i+k]+
					   E*G*DeEG[3*i+k]+
					   F*F*DeFF[3*i+k]+
					   F*G*DeFG[3*i+k]+
					   G*G*DeGG[3*i+k]);	    	  
	}
    }

  delete[] DE;
  delete[] DF;
  delete[] DG;

  delete[] DeEE;
  delete[] DeEF;
  delete[] DeEG;
  delete[] DeFF;
  delete[] DeFG;
  delete[] DeGG;

  delete[] v[0];
  delete[] v[1];
  delete[] v;


#else
  double *K;
  K=new double[M*M];
  Kp(NULL, K);

  for(i=0;i<3*M;i++)
    {
      grad[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      grad[3*i+k] += 2.0 * K[M*j+i] * control_points[k][j];
	    }
	}
    }
  delete[] K;
#endif
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void FirstOrderDataDependentPatch::Hess_KpEnergy(double *Hess)
{
  int i,j,k,l;

#ifdef DATA_DEPENDEND_KP_DERIVATIVES
  if(!FODD_Kp[0][Valence])
    if(!load_Kp())
      {
	cerr << "Error: Can't load energy matrices!"<<endl;
	cerr << "       Call Kp first to compute them."<< endl;
	cerr << "[void FirstOrderDataDependentPatch::Hess_KpEnergy(double *G)]"<< endl;
	exit(1);
      }

  // copy the subdominant eigenvectors
  double **v;
  v=new double*[2];
  v[0]=new double[M];
  v[1]=new double[M];
  if(Valence!=4)
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=iX[Valence][1*M+i];
	  v[1][i]=iX[Valence][2*M+i];  // ??????????? order ????????????
	}
    }
  else
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=VdS4[0][i];
	  v[1][i]=VdS4[1][i];  // ??????????? order ????????????
	}
    }

  // copy the subdominant controlpoints
  double u[3][2];
  if(Valence!=4)
    {
      u[0][0]=ES->eigen_controlpoints[0][1];
      u[1][0]=ES->eigen_controlpoints[1][1];
      u[2][0]=ES->eigen_controlpoints[2][1];
      u[0][1]=ES->eigen_controlpoints[0][2];
      u[1][1]=ES->eigen_controlpoints[1][2];
      u[2][1]=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u[0][0]=0.0;
      u[1][0]=0.0;
      u[2][0]=0.0;
      u[0][1]=0.0;
      u[1][1]=0.0;
      u[2][1]=0.0;
      
      for(i=0;i<16;i++)
	{  
	  u[0][0]+=VdS4[0][i]*control_points[0][i];
	  u[1][0]+=VdS4[0][i]*control_points[1][i];
	  u[2][0]+=VdS4[0][i]*control_points[2][i];
	  u[0][1]+=VdS4[1][i]*control_points[0][i];
	  u[1][1]+=VdS4[1][i]*control_points[1][i];
	  u[2][1]+=VdS4[1][i]*control_points[2][i];
	}
    }

  // compute the three parameters
  double E, F, G;
  E = u[0][0]*u[0][0] + u[1][0]*u[1][0] + u[2][0]*u[2][0];
  F = u[0][0]*u[0][1] + u[1][0]*u[1][1] + u[2][0]*u[2][1];
  G = u[0][1]*u[0][1] + u[1][1]*u[1][1] + u[2][1]*u[2][1];

  //cout << "E="<<E<<", F="<<F<<", G="<<G<<endl;
  // compute the gradients of the parameters
  double *DE;
  double *DF;
  double *DG;
  DE=new double[3*M];
  DF=new double[3*M];
  DG=new double[3*M];
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  DE[3*i+k] = 2.0 * u[k][0] * v[0][i];
	  DF[3*i+k] =       u[k][1] * v[0][i] + 
	                    u[k][0] * v[1][i];
	  DG[3*i+k] = 2.0 * u[k][1] * v[1][i];
	}
    }

  double EE, EF, EG, FF, FG, GG;
  EE=E*E;
  EF=E*F;
  EG=E*G;
  FF=F*F;
  FG=F*G;
  GG=G*G;
   
  // compute the unscaled energies of the 6 quadratic forms
  double eEE, eEF, eEG, eFF, eFG, eGG;
  eEE=0.0;
  eEF=0.0;
  eEG=0.0;
  eFF=0.0;
  eFG=0.0;
  eGG=0.0;
  for(j=0;j<M;j++)
    {
      for(i=0;i<M;i++)
	{
	  double xi, xj;
	  double yi, yj;
	  double zi, zj;
	  double tmp;
	  int    Mji;
	  
	  xi=control_points[0][i]; xj=control_points[0][j];
	  yi=control_points[1][i]; yj=control_points[1][j];
	  zi=control_points[2][i]; zj=control_points[2][j];

	  tmp=xi*xj + yi*yj + zi*zj;

	  Mji=M*j+i;
	  eEE += FODD_Kp[0][Valence][Mji]*tmp;  
	  eEF += FODD_Kp[1][Valence][Mji]*tmp;
	  eEG += FODD_Kp[2][Valence][Mji]*tmp;
	  eFF += FODD_Kp[3][Valence][Mji]*tmp;
	  eFG += FODD_Kp[4][Valence][Mji]*tmp;
	  eGG += FODD_Kp[5][Valence][Mji]*tmp;
	}
    }

  // compute the gradients of the quadratic forms, which is part of the new grad
  double *DeEE;
  double *DeEF;
  double *DeEG;
  double *DeFF;
  double *DeFG;
  double *DeGG;
  DeEE=new double[3*M];
  DeEF=new double[3*M];
  DeEG=new double[3*M];
  DeFF=new double[3*M];
  DeFG=new double[3*M];
  DeGG=new double[3*M];
  
  for(i=0;i<3*M;i++)
    {
      DeEE[i]=0.0;
      DeEF[i]=0.0;
      DeEG[i]=0.0;
      DeFF[i]=0.0;
      DeFG[i]=0.0;
      DeGG[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  for(j=0;j<M;j++)
	    {
	      int Tik, Mij;
	      tmp = 2.0*control_points[k][j];
	      Tik=3*i+k;
	      Mij=M*i+j;
	      
	      DeEE[Tik] += FODD_Kp[0][Valence][Mij]*tmp;  
	      DeEF[Tik] += FODD_Kp[1][Valence][Mij]*tmp;
	      DeEG[Tik] += FODD_Kp[2][Valence][Mij]*tmp;
	      DeFF[Tik] += FODD_Kp[3][Valence][Mij]*tmp;
	      DeFG[Tik] += FODD_Kp[4][Valence][Mij]*tmp;
	      DeGG[Tik] += FODD_Kp[5][Valence][Mij]*tmp;
	    }
	}
    }
	  
  double EGFF;
  EGFF   = pow(EG-FF,-1.5);

  // constants
  double cEE, cEF, cEG, cFF, cFG, cGG;
  cEE=EE*EGFF;
  cEF=EF*EGFF;
  cEG=EG*EGFF;
  cFF=FF*EGFF;
  cFG=FG*EGFF;
  cGG=GG*EGFF;

  // compute the gradient vector of the parameters EE, EF, EG, FF, FG, GG
  double *D_EE;
  double *D_EF;
  double *D_EG;
  double *D_FF;
  double *D_FG;
  double *D_GG;
  D_EE=new double[3*M];
  D_EF=new double[3*M];
  D_EG=new double[3*M];
  D_FF=new double[3*M];
  D_FG=new double[3*M];
  D_GG=new double[3*M];

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  int Tik;
	  
	  Tik=3*i+k;
	  D_EE[Tik] = 2.0 * E*DE[Tik];
	  D_FF[Tik] = 2.0 * F*DF[Tik];
	  D_GG[Tik] = 2.0 * G*DG[Tik];
	  D_EF[Tik] = E*DF[Tik] + F*DE[Tik];
	  D_EG[Tik] = E*DG[Tik] + G*DE[Tik];
	  D_FG[Tik] = F*DG[Tik] + G*DF[Tik];
	}
    }

  // gradient of weird term
  double *D_EGFF;
  D_EGFF=new double[3*M];
  {
    double tmp;
    tmp=-1.5*pow(EG-FF,-2.5);
    for(i=0;i<M;i++)
      {
	for(k=0;k<3;k++)
	  {
	    int Tik;
	    Tik=3*i+k;
	    D_EGFF[Tik] = tmp*(DE[Tik]*G + E*DG[Tik] - 2.0*F*DF[Tik]);
	  }
      }
  }

  // gradients of constants
  double *DcEE;
  double *DcEF;
  double *DcEG;
  double *DcFF;
  double *DcFG;
  double *DcGG;
  DcEE=new double[3*M];
  DcEF=new double[3*M];
  DcEG=new double[3*M];
  DcFF=new double[3*M];
  DcFG=new double[3*M];
  DcGG=new double[3*M];
  
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  int Tik;
	  Tik=3*i+k;
	  DcEE[Tik] = EE*D_EGFF[Tik] + D_EE[Tik] *EGFF;
	  DcFF[Tik] = FF*D_EGFF[Tik] + D_FF[Tik] *EGFF;
	  DcGG[Tik] = GG*D_EGFF[Tik] + D_GG[Tik] *EGFF;
	  DcEF[Tik] = EF*D_EGFF[Tik] + D_EF[Tik] *EGFF;
	  DcEG[Tik] = EG*D_EGFF[Tik] + D_EG[Tik] *EGFF;
	  DcFG[Tik] = FG*D_EGFF[Tik] + D_FG[Tik] *EGFF;
	}
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  int Tik;
	  Tik=3*i+k;
	  
	  double t12, t14, t16;
	  t12 = DE[Tik]; //diff(E(x,y),x);
	  t14 = DG[Tik]; //diff(G(x,y),x);
	  t16 = DF[Tik]; //diff(F(x,y),x);

	  for(j=i;j<M;j++)
	    {
	      for(l=0;l<3;l++)
		{
		  int Tjl;

		  Tjl=3*j+l;

		  double DDE, DDF, DDG;
		  double DDeEE, DDeEF, DDeEG, DDeFF, DDeFG, DDeGG; 

		  if(l==k)
		    {
		      DDE = 2.0 * v[0][j]*v[0][i];
		      DDF =       v[1][j]*v[0][i] + 
		   	          v[0][j]*v[1][i];
		      DDG = 2.0 * v[1][j]*v[1][i];

		      DDeEE = 2.0*FODD_Kp[0][Valence][M*i+j];
		      DDeEF = 2.0*FODD_Kp[1][Valence][M*i+j];
		      DDeEG = 2.0*FODD_Kp[2][Valence][M*i+j];
		      DDeFF = 2.0*FODD_Kp[3][Valence][M*i+j];
		      DDeFG = 2.0*FODD_Kp[4][Valence][M*i+j];
		      DDeGG = 2.0*FODD_Kp[5][Valence][M*i+j];
		    }
		  else 
		    {
		      DDE=0.0;
		      DDF=0.0;
		      DDG=0.0;

		      DDeEE=0.0;
		      DDeEF=0.0;
		      DDeEG=0.0;
		      DDeFF=0.0;
		      DDeFG=0.0;
		      DDeGG=0.0;
		    }

		  double t1, t2, t4;
		  t1 = E;
		  t2 = G;
		  t4 = F;

		  double t21, t23, t25, t33, t37, t41;
		  t21 = DE[Tjl]; //diff(E(x,y),y);
		  t23 = DG[Tjl]; //diff(G(x,y),y);
		  t25 = DF[Tjl]; //diff(F(x,y),y);
		  t33 = DDE; //diff(diff(E(x,y),x),y);
		  t37 = DDG; //diff(diff(G(x,y),x),y);
		  t41 = DDF; //diff(diff(F(x,y),x),y);

		  double t5, t6, t7, t9;
		  t5 = t4*t4;
		  t6 = t2*t1-t5;
		  t7 = t6*t6;
		  t9 = sqrt(t6);

		  double DD_EGFF;
		  DD_EGFF = 15.0/4.0/t9/t7/t6*
		    (t12*t2+t1*t14-2.0*t4*t16)*
		    (t21*t2+t1*t23-2.0*t4*t25)-
		    3.0/2.0/t9/t7*
		    (t33*t2+t12*t23+t21*t14+t1*t37-2.0*t25*t16-2.0*t4*t41);


		  double DDEE, DDEF, DDEG, DDFF, DDFG, DDGG;
		  DDEE = 2.0*(DDE *E + DE[Tik]*DE[Tjl]);
		  DDFF = 2.0*(DDF *F + DF[Tik]*DF[Tjl]);
		  DDGG = 2.0*(DDG *G + DG[Tik]*DG[Tjl]);

		  DDEF = DDE *F + (DE[Tik]*DF[Tjl] + 
				   DE[Tjl]*DF[Tik])+ 
 		       E*DDF;
		  DDEG = DDE *G + (DE[Tik]*DG[Tjl] + 
				   DE[Tjl]*DG[Tik])+ 
		       E*DDG;
		  DDFG = DDF *G + (DF[Tik]*DG[Tjl] + 
				   DF[Tjl]*DG[Tik])+
  		       F*DDG;

		  double DDcEE, DDcEF, DDcEG, DDcFF, DDcFG, DDcGG;
		  DDcEE = DDEE*EGFF+(D_EE[Tik]*D_EGFF[Tjl]+
				     D_EE[Tjl]*D_EGFF[Tik])+EE*DD_EGFF;
		  DDcEF = DDEF*EGFF+(D_EF[Tik]*D_EGFF[Tjl]+
				     D_EF[Tjl]*D_EGFF[Tik])+EF*DD_EGFF;
		  DDcEG = DDEG*EGFF+(D_EG[Tik]*D_EGFF[Tjl]+
				     D_EG[Tjl]*D_EGFF[Tik])+EG*DD_EGFF;
		  DDcFF = DDFF*EGFF+(D_FF[Tik]*D_EGFF[Tjl]+
				     D_FF[Tjl]*D_EGFF[Tik])+FF*DD_EGFF;
		  DDcFG = DDFG*EGFF+(D_FG[Tik]*D_EGFF[Tjl]+
				     D_FG[Tjl]*D_EGFF[Tik])+FG*DD_EGFF;
		  DDcGG = DDGG*EGFF+(D_GG[Tik]*D_EGFF[Tjl]+
				     D_GG[Tjl]*D_EGFF[Tik])+GG*DD_EGFF;


		  Hess[3*M*(Tik)+(Tjl)]=  (DDcEE       *  eEE+
					      DcEE[Tik]* DeEE[Tjl]+
					      DcEE[Tjl]* DeEE[Tik]+
					       cEE       *DDeEE
					     )+
		                          (DDcEF       *  eEF+
					      DcEF[Tik]* DeEF[Tjl]+
					      DcEF[Tjl]* DeEF[Tik]+
					       cEF       *DDeEF
					     )+
		                          (DDcEG       *  eEG+
					      DcEG[Tik]* DeEG[Tjl]+
					      DcEG[Tjl]* DeEG[Tik]+
					       cEG       *DDeEG
					     )+
 		                          (DDcFF       *  eFF+
					      DcFF[Tik]* DeFF[Tjl]+
					      DcFF[Tjl]* DeFF[Tik]+
					       cFF       *DDeFF
					     )+
		                          (DDcFG       *  eFG+
					      DcFG[Tik]* DeFG[Tjl]+
					      DcFG[Tjl]* DeFG[Tik]+
					       cFG       *DDeFG
					     )+
		                          (DDcGG       *  eGG+
					      DcGG[Tik]* DeGG[Tjl]+
					      DcGG[Tjl]* DeGG[Tik]+
					       cGG       *DDeGG
					     );
		}
	    }
	}
    }

  // computed only lower half of matrix, mirror up!
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  for(j=i;j<M;j++)
	    {
	      for(l=0;l<3;l++)
		{
		  Hess[3*M*(3*j+l)+(3*i+k)]=Hess[3*M*(3*i+k)+(3*j+l)];
		}
	    }
	}
    }

#ifdef DEBUG
  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {	      
	      for(l=0;l<3;l++)
		{
		  if(fabs(Hess[3*M*(3*i+k)+(3*j+l)])>1.0e9)
		    {
		      cerr << "Warning: Huge derivatives in FirstOrderDataDependentPatch::Hess()"<<endl;
		      exit(1);
		    }

		  if(fabs(Hess[3*M*(3*j+l)+(3*i+k)]-Hess[3*M*(3*i+k)+(3*j+l)])>1e-6) 
		    {
		      cerr << "Hess not symmetric!" << endl;
		      cerr << "i="<<i<<", k="<<k<<", j="<<j<<", l="<<l<<endl;
      		      cerr << Hess[3*M*(3*j+l)+(3*i+k)] << "!=" 
			   << Hess[3*M*(3*i+k)+(3*j+l)] << endl;

		      exit(1);
		    }
		}
	    }
	}
    }
#endif
  delete[] DE;
  delete[] DF;
  delete[] DG;

  delete[] D_EE;
  delete[] D_EF;
  delete[] D_EG;
  delete[] D_FF;
  delete[] D_FG;
  delete[] D_GG;

  delete[] DcEE;
  delete[] DcEF;
  delete[] DcEG;
  delete[] DcFF;
  delete[] DcFG;
  delete[] DcGG;

  delete[] D_EGFF;

  delete[] DeEE;
  delete[] DeEF;
  delete[] DeEG;
  delete[] DeFF;
  delete[] DeFG;
  delete[] DeGG;
  
  delete[] v[0];
  delete[] v[1];
  delete[] v;

#else

  double *K;
  K=new double[M*M];
  Kp(NULL, K);

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      for(l=0;l<3;l++)
		{
		  Hess[(3*M)*(3*i+k) + 3*j+l] = 0.0;
		}
	    }
	  for(k=0;k<3;k++)
	    {
	      Hess[(3*M)*(3*i+k) + 3*j+k] = 2.0 * K[M*i+j];
	    }
	}
    }
  delete[] K;
#endif

#ifdef DEBUG
  for(i=0;i<3*M;i++)
    {
      for(j=0;j<3*M;j++)
	{
	  if(fabs(Hess[i*3*M+j]-Hess[j*3*M+i])>1e-6)
	    cout <<"Hess "<< i << ", " << j << ", " << Hess[i*3*M+j]
		 <<"!="<< Hess[j*3*M+i] << endl;
	}
    }
#endif
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


