//////////////////////////////////////////////////////////////////////////////
//
// FirstOrderDataDependentPatch_membrane.cpp, 05/19/02, Ilja Friedel
//
//////////////////////////////////////////////////////////////////////////////

#include "FirstOrderDataDependentPatch.h"

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Status: done, not debugged

int FirstOrderDataDependentPatch::load_Km(void)
{
  int  i,j,xxx;
  FILE *f;
  char fname[256];

  for(xxx=0;xxx<3;xxx++)
    {
      FODD_Km[xxx][Valence]=new double[M*M];
      assert(FODD_Km[xxx][Valence]);
    }

  for(xxx=0;xxx<3;xxx++)
    {
      if(xxx==0) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_E.mtx",Valence);
      if(xxx==1) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_F.mtx",Valence);
      if(xxx==2) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_G.mtx",Valence);
      
      f=fopen(fname,"r");
      if(!f)
	{
	  return(0);
	}
      
      for(i=0;i<M;i++)
	{
	  for(j=0;j<M;j++)
	    {
	      fscanf(f,"%lf",&(FODD_Km[xxx][Valence][i*M+j]));
	    }
	  fscanf(f,"\n");
	}
      fclose(f);
    }
  return(1);
}

//////////////////////////////////////////////////////////////////////////////
// status: changed, not debugged

void FirstOrderDataDependentPatch::save_Km(void)
{
  int i,j,xxx;
  FILE *f;
  char fname[256];

  for(xxx=0;xxx<3;xxx++)
    {
      if(xxx==0) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_E.mtx",Valence);
      if(xxx==1) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_F.mtx",Valence);
      if(xxx==2) 
	sprintf(fname,"data/FirstOrderDataDependent_K/Km/FODD_Valence_%d_Km_G.mtx",Valence);
      
      f=fopen(fname,"w");
      for(i=0;i<M;i++)
	{
	  for(j=0;j<M;j++)
	    {
	      fprintf(f,"%1.18e\t",FODD_Km[xxx][Valence][i*M+j]);
	    }
	  fprintf(f,"\n");
	}
      fclose(f);
    }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// status: changed, not debugged

double FirstOrderDataDependentPatch::Km_function(const double u1, const double u2)
{
  double tmp;
  double u,v;

  u=u1;
  v=u2;

  assert(u>=0.0 && u<=1.0);
  assert(v>=0.0 && v<=1.0);

  //double X,Y,Z;

  double d1Ch1, d2Ch1;
  double d1Ch2, d2Ch2;

  double d1hi, d2hi;
  double d1hj, d2hj;

  // the characteristic map is the reference surface

  d1Ch1  = ES->evaluate_D1phi(u,v,1);
  d2Ch1  = ES->evaluate_D2phi(u,v,1);
  d1Ch2  = ES->evaluate_D1phi(u,v,2);
  d2Ch2  = ES->evaluate_D2phi(u,v,2);

  // the derivatives of the i'th eigenfunction

  d1hi   = ES->evaluate_D1phi(u,v,IL_i);
  d2hi   = ES->evaluate_D2phi(u,v,IL_i);

  // the derivatives of the j'th eigenfunction

  d1hj   = ES->evaluate_D1phi(u,v,IL_j);
  d2hj   = ES->evaluate_D2phi(u,v,IL_j);

  //(d2hi*d1Ch1^2*d2hj*E+d1hi*d2Ch1^2*d1hj*E-d1hi*d2Ch1*d2hj*d1Ch1*E-d2hi*d1Ch1*d1hj*d2Ch1*E
  //-d1hi*d2Ch1*d2hj*d1Ch2*F-d2hi*d1Ch2*d1hj*d2Ch1*F-d2hi*d1Ch1*d1hj*d2Ch2*F+2*d2hi*d1Ch1*d2hj*d1Ch2*F+2*d1hi*d2Ch1*d1hj*d2Ch2*F-d1hi*d2Ch2*d2hj*d1Ch1*F
  //-d1hi*d2Ch2*d2hj*d1Ch2*G-d2hi*d1Ch2*d1hj*d2Ch2*G+d2hi*d1Ch2^2*d2hj*G+d1hi*d2Ch2^2*d1hj*G)
  // /abs(d1Ch1*d2Ch2-d1Ch2*d2Ch1)

  if(xx==0) // E
    {
      tmp = 
	d2hi*d1Ch1*d1Ch1*d2hj+
	d1hi*d2Ch1*d2Ch1*d1hj-
	d1hi*d2Ch1*d2hj*d1Ch1-
	d2hi*d1Ch1*d1hj*d2Ch1;
    }
  else if(xx==1) // F
    {
      tmp = 
       -d1hi*d2Ch1*d2hj*d1Ch2-
	d2hi*d1Ch2*d1hj*d2Ch1-
	d2hi*d1Ch1*d1hj*d2Ch2+
    2.0*d2hi*d1Ch1*d2hj*d1Ch2+
    2.0*d1hi*d2Ch1*d1hj*d2Ch2-
	d1hi*d2Ch2*d2hj*d1Ch1;
    }
  else if(xx==2) // G
    {
      tmp = 
       -d1hi*d2Ch2*d2hj*d1Ch2-
	d2hi*d1Ch2*d1hj*d2Ch2+
	d2hi*d1Ch2*d1Ch2*d2hj+
	d1hi*d2Ch2*d2Ch2*d1hj;
    }
  else 
    {
      cerr << "Error: No valid xx selected in FODDP::Km_function!"<<endl;
      exit(1);
    }

  return(tmp/fabs(d2Ch2*d1Ch1-d1Ch2*d2Ch1));
}

//////////////////////////////////////////////////////////////////////////////
// changed, not debugged

void FirstOrderDataDependentPatch::Km(Patch *S, double *K)
{
  int    i, j, k;
  double t;
  double *tmp;
  double E,F,G;

  assert(S==NULL);

  if(!FODD_Km[0][Valence])
    if(!load_Km())
      {
	// compute the matrices and save them to disc
	tmp=new double[M*M];

	for(xx=0;xx<3;xx++)
	  {
	    for(IL_i=0;IL_i<M;IL_i++)
	      {
		for(IL_j=IL_i;IL_j<M;IL_j++)
		  {
		    double tmp_I;

		    if(IL_i==0||IL_j==0) tmp_I=0.0;
		    else
		      {
			double lambda_i, lambda_j;
			
			//tmp_I=Integrate((F2D)&FirstOrderDataDependentPatch::Km_function,
			//	    0.0,1.0, 0.0,1.0);
			
			tmp_I =Integrate((F2D)&FirstOrderDataDependentPatch::Km_function,
					0.5,1.0, 0.5,1.0);

			tmp_I+=Integrate((F2D)&FirstOrderDataDependentPatch::Km_function,
					0.0,0.5, 0.5,1.0);

			tmp_I+=Integrate((F2D)&FirstOrderDataDependentPatch::Km_function,
					0.5,1.0, 0.0,0.5);
			
			lambda_i=Lambda[Valence][IL_i*M+IL_i];
			lambda_j=Lambda[Valence][IL_j*M+IL_j];
			tmp_I=tmp_I/(1.0-lambda_i*lambda_j);
			
		      }
		    K[M*IL_j+IL_i]=tmp_I;
		    K[M*IL_i+IL_j]=tmp_I;
		    
		    cout<<".";
		    fflush(0);
		  }
		cout<<endl;
	      }
	    
	    FODD_Km[xx][Valence]=new double[M*M];
	    assert(FODD_Km[xx][Valence]);

	    // K=mult(transpose(iX)*K*iX);
	    for(i=0;i<M;++i)
	      {
		for(k=0;k<M;++k) 
		  {
		    t=0.0;
		    for(j=0;j<M;++j )
		      {
			t+=K[i*M+j]*iX[Valence][j*M+k];
		      }
		    tmp[i*M+k]=t;
		  }
	      }
	    for(i=0;i<M;++i)
	      {
		for(k=0;k<M;++k) 
		  {
		    t=0.0;
		    for(j=0;j<M;++j )
		      {
			t+=iX[Valence][j*M+i]*tmp[j*M+k];
		      } //             ^^^^^ j and i transposed
		    FODD_Km[xx][Valence][i*M+k]=t;
		  }
	      }
	    save_Km();
	  }
	delete[] tmp;
      }

  double u11, u21, u31;
  double u12, u22, u32;

  if(Valence!=4)
    {
      u11=ES->eigen_controlpoints[0][1];
      u21=ES->eigen_controlpoints[1][1];
      u31=ES->eigen_controlpoints[2][1];
      u12=ES->eigen_controlpoints[0][2];
      u22=ES->eigen_controlpoints[1][2];
      u32=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u11=0.0;
      u21=0.0;
      u31=0.0;
      u12=0.0;
      u22=0.0;
      u32=0.0;
      
      for(i=0;i<16;i++)
	{	  
	  u11+=VdS4[0][i]*control_points[0][i];
	  u21+=VdS4[0][i]*control_points[1][i];
	  u31+=VdS4[0][i]*control_points[2][i];
	  u12+=VdS4[1][i]*control_points[0][i];
	  u22+=VdS4[1][i]*control_points[1][i];
	  u32+=VdS4[1][i]*control_points[2][i];
	}
    }

  E = u11*u11 + u21*u21 + u31*u31;
  F = u11*u12 + u21*u22 + u31*u32;
  G = u12*u12 + u22*u22 + u32*u32;

  /*
  E = 1.0;
  F = 0.0;
  G = 1.0;
 
  //cerr << "E=1,F=0,G=1";
  */

  for(i=0;i<M*M;i++) K[i] = pow(E*G-F*F,-0.5)*
		                     (E * FODD_Km[0][Valence][i] + 
				      F * FODD_Km[1][Valence][i] +
				      G * FODD_Km[2][Valence][i]);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// this function is for debugging only
// status: done, not debugged

void FirstOrderDataDependentPatch::save_membrane_integrands(int mode_i, int mode_j, int coeff)
{
  int N,M;
  int i,j;
  char fn[256];
  
  FILE *f;

  IL_i=mode_i;
  IL_j=mode_j;
  xx=coeff;

  cout << "IL_i="<<IL_i<<", IL_j="<<IL_j<<", xx="<<xx<<endl;

  assert(IL_i<Valence*2+8);
  assert(IL_j<Valence*2+8);
  assert(xx<3);

  sprintf(fn,"KmInt_Valence%d_Coeff%d_mode%d_mode%d.iv",Valence,coeff,mode_i,mode_j);

  N=30;
  M=30;

  f=fopen(fn,"w");
  assert(f);
  
  fprintf(f,"#Inventor V2.0 ascii\n\n");
  fprintf(f,"Separator {\n");
  fprintf(f,"	LightModel\n");
  fprintf(f,"	{\n");
  fprintf(f,"	   #model BASE_COLOR\n");
  fprintf(f,"	}\n");
  fprintf(f,"	ShapeHints {\n");
  fprintf(f,"	shapeType UNKNOWN_SHAPE_TYPE\n");
  fprintf(f,"	vertexOrdering	COUNTERCLOCKWISE\n");
  fprintf(f,"	}\n");

  fprintf(f,"    Coordinate3 {\n");
  fprintf(f,"	point	[\n");

  for(i=0;i<=N;i++)
    {
      for(j=0;j<=M;j++)
	{
	  if(i==N && j==M)
	    {
	      fprintf(f,"         %e %e %e",
		      (i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1),
		      Km_function((i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1)));
	    }
	  else
	    {
	      fprintf(f,"         %e %e %e,",
		      (i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1),
		      Km_function((i+0.5)/(double)(N+1),(j+0.5)/(double)(M+1)));
	    }
	  fprintf(f,"\n");
	}
    }

  fprintf(f,"    ]}\n");
  fprintf(f,"    QuadMesh {\n");
  fprintf(f,"	verticesPerColumn	%d\n",N+1);
  fprintf(f,"	verticesPerRow	%d\n",M+1);
  fprintf(f,"    }\n");
  fprintf(f,"}\n");

  fclose(f);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// compute Km matrix and from that get the energy approximation
// status: ok, not debugged

double FirstOrderDataDependentPatch::KmEnergy(void)
{
  double *K;
  double E;
  int i,j;

  E=0.0;
  
  K=new double[M*M];
  Km(NULL,K);
  for(i=0;i<2*Valence+8;i++)
    {
      for(j=i+1;j<2*Valence+8;j++)
	{
	  E=E+K[(2*Valence+8)*i+j]*
	    (control_points[0][i]*control_points[0][j]+
	     control_points[1][i]*control_points[1][j]+
	     control_points[2][i]*control_points[2][j]);
	}
    }
  E=E*2.0;
  for(i=0;i<2*Valence+8;i++)
     {
	  E=E+K[(2*Valence+8)*i+i]*
	    (control_points[0][i]*control_points[0][i]+
	     control_points[1][i]*control_points[1][i]+
	     control_points[2][i]*control_points[2][i]);
     }
  delete[] K;

  return E;
}

//////////////////////////////////////////////////////////////////////////////
// function mostly for debugging purposes
// status: changed. First debug ok.

void FirstOrderDataDependentPatch::grad_KmEnergy_central_diff(double *G)
{
  FirstOrderDataDependentPatch *FP1;
  FirstOrderDataDependentPatch *FP2;
  double diff,tmp;
  int i, coord;

  for(i=0;i<2*Valence+8;i++)
    {
      for(coord=0;coord<3;coord++)
	{

	  tmp=control_points[coord][i];

	  control_points[coord][i]=tmp+EPSILON2;
	  FP1=new FirstOrderDataDependentPatch(control_points, Valence);
	  control_points[coord][i]=tmp-EPSILON2;
	  FP2=new FirstOrderDataDependentPatch(control_points, Valence);

	  diff=(FP1->KmEnergy() - FP2->KmEnergy())/(2.0*EPSILON2);

	  delete(FP1);
	  delete(FP2);
	  control_points[coord][i]=tmp;
	  
	  G[3*i+coord]=diff;
	}
    }
}

//////////////////////////////////////////////////////////////////////////////
// status: First debug done

void FirstOrderDataDependentPatch::Hess_KmEnergy_central_diff(double *Hess)
{
  int    i,j,k;
  double diff;
  FirstOrderDataDependentPatch *FP11, *FP12;

  for(i=0;i<9*M*M;i++)
    {
      Hess[i] = 0.0;
    }
#define CENTRAL_DIFF_def
#ifdef CENTRAL_DIFF_def
  // **********************************************************************************
  // central differences
  // **********************************************************************************
  double tmp1,tmp2;
  double diff1,diff2;
  int l;
  FirstOrderDataDependentPatch *FP21, *FP22;

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      for(l=0;l<3;l++)
		{
		  tmp1=control_points[k][i];
		  tmp2=control_points[l][j];

		  if(i==j && k==l)
		    {
		      FP22=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1+EPSILON3;
		      FP11=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      FP12=new FirstOrderDataDependentPatch(control_points, Valence);
		      
		      diff=(FP11->KmEnergy() + FP12->KmEnergy() - 2.0*FP22->KmEnergy()); 

		      diff=diff/(EPSILON3*EPSILON3);
		    }
		  else
		    {
		      control_points[k][i]=tmp1+EPSILON3;
		      control_points[l][j]=tmp2+EPSILON3;
		      FP11=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1+EPSILON3;
		      control_points[l][j]=tmp2-EPSILON3;
		      FP12=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      control_points[l][j]=tmp2+EPSILON3;
		      FP21=new FirstOrderDataDependentPatch(control_points, Valence);
		      control_points[k][i]=tmp1-EPSILON3;
		      control_points[l][j]=tmp2-EPSILON3;
		      FP22=new FirstOrderDataDependentPatch(control_points, Valence);
		      
		      diff1=(FP11->KmEnergy() - FP12->KmEnergy())/(2.0*EPSILON3);
		      diff2=(FP21->KmEnergy() - FP22->KmEnergy())/(2.0*EPSILON3);
		      diff=(diff1-diff2)/(2.0*EPSILON3);
		    }

		  Hess[3*M*(3*j+l)+(3*i+k)]+=0.5*diff;
		  Hess[3*M*(3*i+k)+(3*j+l)]+=0.5*diff;

		  delete(FP11);
		  delete(FP12);
		  if(!(i==j && k==l))
		    {
		      delete(FP21);
		    }
		  delete(FP22);
		  control_points[k][i]=tmp1;
		  control_points[l][j]=tmp2;
		}
	    }
	}
    }
#else
  // **********************************************************************************
  // repeated gradient (which we know works) is used
  // **********************************************************************************

  double *G1;
  double *G2;
  double tmp;

  G1=new double[3*M];
  G2=new double[3*M];

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  tmp=control_points[k][i];

	  control_points[k][i]=tmp+EPSILON2;
	  FP11=new FirstOrderDataDependentPatch(control_points, Valence);

	  control_points[k][i]=tmp-EPSILON2;
	  FP12=new FirstOrderDataDependentPatch(control_points, Valence);
	  control_points[k][i]=tmp;

	  FP11->grad_KmEnergy(G1);
	  FP12->grad_KmEnergy(G2);

	  for(j=0;j<3*M;j++)
	    {
	      diff=(G1[j] - G2[j])/(2.0*EPSILON2);
	      Hess[3*M*(  j  )+(3*i+k)]+=0.5*diff;
	      Hess[3*M*(3*i+k)+(  j  )]+=0.5*diff;	     
	    }
	  
	  delete(FP11);
	  delete(FP12);
	}
    }
  delete[] G1;
  delete[] G2;

#endif
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Status: changed, First Debug ok.

void FirstOrderDataDependentPatch::grad_KmEnergy(double *grad)
{
  int i,j,k;

#define EXACT_KM_DERIVATIVES
#ifdef EXACT_KM_DERIVATIVES
  if(!FODD_Km[0][Valence])
    if(!load_Km())
      {
	cerr << "Error: Can't load energy matrices!"<<endl;
	cerr << "       Call Km first to compute them."<< endl;
	cerr << "[void FirstOrderDataDependentPatch::grad_KmEnergy(double *G)]"<< endl;
	exit(1);
      }


  // copy the subdominant eigenvectors
  double **v;
  v=new double*[2];
  v[0]=new double[M];
  v[1]=new double[M];
  if(Valence!=4)
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=iX[Valence][1*M+i];
	  v[1][i]=iX[Valence][2*M+i];  // ??????????? order ????????????
	}
    }
  else
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=VdS4[0][i];
	  v[1][i]=VdS4[1][i];  // ??????????? order ????????????
	}
    }

  // copy the subdominant controlpoints
  double u[3][2];
  if(Valence!=4)
    {
      u[0][0]=ES->eigen_controlpoints[0][1];
      u[1][0]=ES->eigen_controlpoints[1][1];
      u[2][0]=ES->eigen_controlpoints[2][1];
      u[0][1]=ES->eigen_controlpoints[0][2];
      u[1][1]=ES->eigen_controlpoints[1][2];
      u[2][1]=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u[0][0]=0.0;
      u[1][0]=0.0;
      u[2][0]=0.0;
      u[0][1]=0.0;
      u[1][1]=0.0;
      u[2][1]=0.0;
      
      for(i=0;i<16;i++)
	{  
	  u[0][0]+=VdS4[0][i]*control_points[0][i];
	  u[1][0]+=VdS4[0][i]*control_points[1][i];
	  u[2][0]+=VdS4[0][i]*control_points[2][i];
	  u[0][1]+=VdS4[1][i]*control_points[0][i];
	  u[1][1]+=VdS4[1][i]*control_points[1][i];
	  u[2][1]+=VdS4[1][i]*control_points[2][i];
	}
    }

  // compute the three parameters
  double E, F, G;
  E = u[0][0]*u[0][0] + u[1][0]*u[1][0] + u[2][0]*u[2][0];
  F = u[0][0]*u[0][1] + u[1][0]*u[1][1] + u[2][0]*u[2][1];
  G = u[0][1]*u[0][1] + u[1][1]*u[1][1] + u[2][1]*u[2][1];

  //cout << "E="<<E<<", F="<<F<<", G="<<G<<endl;

  // compute the gradients of the parameters
  double *DE;
  double *DF;
  double *DG;
  DE=new double[3*M];
  DF=new double[3*M];
  DG=new double[3*M];
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  DE[3*i+k] = 2.0 * u[k][0] * v[0][i];
	  DF[3*i+k] =       u[k][1] * v[0][i] + 
	                    u[k][0] * v[1][i];
	  DG[3*i+k] = 2.0 * u[k][1] * v[1][i];
	}
    }

  //cout << endl;
      
  // compute the unscaled energies of the 6 quadratic forms
  double eE, eF, eG;
  eE=0.0;
  eF=0.0;
  eG=0.0;
  for(j=0;j<M;j++)
    {
      for(i=0;i<M;i++)
	{
	  double xi, xj;
	  double yi, yj;
	  double zi, zj;
	  double tmp;
	  
	  xi=control_points[0][i]; xj=control_points[0][j];
	  yi=control_points[1][i]; yj=control_points[1][j];
	  zi=control_points[2][i]; zj=control_points[2][j];

	  tmp=xi*xj + yi*yj + zi*zj;

	  eE += FODD_Km[0][Valence][M*j+i]*tmp;  
	  eF += FODD_Km[1][Valence][M*j+i]*tmp;
	  eG += FODD_Km[2][Valence][M*j+i]*tmp;
	}
    }

  // compute the gradients of the quadratic forms, which is part of the new grad
  double *DeE;
  double *DeF;
  double *DeG;
  DeE=new double[3*M];
  DeF=new double[3*M];
  DeG=new double[3*M];
  for(i=0;i<3*M;i++)
    {
      DeE[i]=0.0;
      DeF[i]=0.0;
      DeG[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  for(j=0;j<M;j++)
	    {
	      tmp = control_points[k][j];
	      DeE[3*i+k] += 2.0 * FODD_Km[0][Valence][M*i+j]*tmp;  
	      DeF[3*i+k] += 2.0 * FODD_Km[1][Valence][M*i+j]*tmp;
	      DeG[3*i+k] += 2.0 * FODD_Km[2][Valence][M*i+j]*tmp;
	    }
	}
    }
	  
  // compute and add the correction factor to get the gradient of the energy
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  double DcE, DcF, DcG;
	  double D_EGFF,EGFF;

	  EGFF   =      pow(E*G-F*F,-0.5);  // **** put out of loop
	  D_EGFF = -0.5*pow(E*G-F*F,-1.5)*(DE[3*i+k]*G + E*DG[3*i+k] - 2.0*F*DF[3*i+k]);

	  DcE = E*D_EGFF + DE[3*i+k] *EGFF;
	  DcF = F*D_EGFF + DF[3*i+k] *EGFF;
	  DcG = G*D_EGFF + DG[3*i+k] *EGFF;

	  grad[3*i+k] = eE * DcE +
	                eF * DcF +
	                eG * DcG +
	                EGFF*(E*DeE[3*i+k]+
			      F*DeF[3*i+k]+
			      G*DeG[3*i+k]);
	}
    }

  delete[] DE;
  delete[] DF;
  delete[] DG;

  delete[] DeE;
  delete[] DeF;
  delete[] DeG;

  delete[] v[0];
  delete[] v[1];
  delete[] v;


#else
  double *K;
  K=new double[M*M];
  Km(NULL, K);

  for(i=0;i<3*M;i++)
    {
      grad[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      grad[3*i+k] += 2.0 * K[M*j+i] * control_points[k][j];
	    }
	}
    }
  delete[] K;
#endif
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Status: changed, not tested

void FirstOrderDataDependentPatch::Hess_KmEnergy(double *Hess)
{
  int i,j,k,l;

#ifdef EXACT_KM_DERIVATIVES
  if(!FODD_Km[0][Valence])
    if(!load_Km())
      {
	cerr << "Error: Can't load energy matrices!"<<endl;
	cerr << "       Call Km first to compute them."<< endl;
	cerr << "[void FirstOrderDataDependentPatch::Hess_KmEnergy(double *G)]"<< endl;
	exit(1);
      }

  // copy the subdominant eigenvectors
  double **v;
  v=new double*[2];
  v[0]=new double[M];
  v[1]=new double[M];
  if(Valence!=4)
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=iX[Valence][1*M+i];
	  v[1][i]=iX[Valence][2*M+i];  // ??????????? order ????????????
	}
    }
  else
    {
      for(i=0;i<M;i++)
	{
	  v[0][i]=VdS4[0][i];
	  v[1][i]=VdS4[1][i];  // ??????????? order ????????????
	}
    }

  // copy the subdominant controlpoints
  double u[3][2];
  if(Valence!=4)
    {
      u[0][0]=ES->eigen_controlpoints[0][1];
      u[1][0]=ES->eigen_controlpoints[1][1];
      u[2][0]=ES->eigen_controlpoints[2][1];
      u[0][1]=ES->eigen_controlpoints[0][2];
      u[1][1]=ES->eigen_controlpoints[1][2];
      u[2][1]=ES->eigen_controlpoints[2][2];
    }
  else
    {
      u[0][0]=0.0;
      u[1][0]=0.0;
      u[2][0]=0.0;
      u[0][1]=0.0;
      u[1][1]=0.0;
      u[2][1]=0.0;
      
      for(i=0;i<16;i++)
	{  
	  u[0][0]+=VdS4[0][i]*control_points[0][i];
	  u[1][0]+=VdS4[0][i]*control_points[1][i];
	  u[2][0]+=VdS4[0][i]*control_points[2][i];
	  u[0][1]+=VdS4[1][i]*control_points[0][i];
	  u[1][1]+=VdS4[1][i]*control_points[1][i];
	  u[2][1]+=VdS4[1][i]*control_points[2][i];
	}
    }

  // compute the three parameters
  double E, F, G;
  E = u[0][0]*u[0][0] + u[1][0]*u[1][0] + u[2][0]*u[2][0];
  F = u[0][0]*u[0][1] + u[1][0]*u[1][1] + u[2][0]*u[2][1];
  G = u[0][1]*u[0][1] + u[1][1]*u[1][1] + u[2][1]*u[2][1];

  //cout << "E="<<E<<", F="<<F<<", G="<<G<<endl;
  // compute the gradients of the parameters
  double *DE;
  double *DF;
  double *DG;
  DE=new double[3*M];
  DF=new double[3*M];
  DG=new double[3*M];
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  DE[3*i+k] = 2.0 * u[k][0] * v[0][i];
	  DF[3*i+k] =       u[k][1] * v[0][i] + 
	                    u[k][0] * v[1][i];
	  DG[3*i+k] = 2.0 * u[k][1] * v[1][i];
	}
    }

  // compute the unscaled energies of the 6 quadratic forms
  double eE, eF, eG;
  eE=0.0;
  eF=0.0;
  eG=0.0;
  for(j=0;j<M;j++)
    {
      for(i=0;i<M;i++)
	{
	  double xi, xj;
	  double yi, yj;
	  double zi, zj;
	  double tmp;
	  
	  xi=control_points[0][i]; xj=control_points[0][j];
	  yi=control_points[1][i]; yj=control_points[1][j];
	  zi=control_points[2][i]; zj=control_points[2][j];

	  tmp=xi*xj + yi*yj + zi*zj;

	  eE += FODD_Km[0][Valence][M*j+i]*tmp;  
	  eF += FODD_Km[1][Valence][M*j+i]*tmp;
	  eG += FODD_Km[2][Valence][M*j+i]*tmp;
	}
    }

  // compute the gradients of the quadratic forms, which is part of the new grad
  double *DeE;
  double *DeF;
  double *DeG;
  DeE=new double[3*M];
  DeF=new double[3*M];
  DeG=new double[3*M];
  
  for(i=0;i<3*M;i++)
    {
      DeE[i]=0.0;
      DeF[i]=0.0;
      DeG[i]=0.0;
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  for(j=0;j<M;j++)
	    {
	      tmp = control_points[k][j];
	      DeE[3*i+k] += 2.0 * FODD_Km[0][Valence][M*i+j]*tmp;  
	      DeF[3*i+k] += 2.0 * FODD_Km[1][Valence][M*i+j]*tmp;
	      DeG[3*i+k] += 2.0 * FODD_Km[2][Valence][M*i+j]*tmp;
	    }
	}
    }
	  
  double EGFF;
  EGFF   = pow(E*G-F*F,-0.5);

  // constants
  double cE, cF, cG;
  cE=E*EGFF;
  cF=F*EGFF;
  cG=G*EGFF;

  // compute the gradient vector of the parameters EE, EF, EG, FF, FG, GG
  double *D_EG;
  double *D_FF;
  D_EG=new double[3*M];
  D_FF=new double[3*M];

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  D_FF[3*i+k] = 2.0 * F*DF[3*i+k];
	  D_EG[3*i+k] = E*DG[3*i+k] + G*DE[3*i+k];
	}
    }

  // gradient of weird term
  double *D_EGFF;
  D_EGFF=new double[3*M];
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  D_EGFF[3*i+k] = -0.5*pow(E*G-F*F,-1.5)*
	                      (DE[3*i+k]*G + E*DG[3*i+k] - 2.0*F*DF[3*i+k]);
	}
    }

  // gradients of constants
  double *DcE;
  double *DcF;
  double *DcG;
  DcE=new double[3*M];
  DcF=new double[3*M];
  DcG=new double[3*M];
  
  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  DcE[3*i+k] = E*D_EGFF[3*i+k] + DE[3*i+k] *EGFF;
	  DcF[3*i+k] = F*D_EGFF[3*i+k] + DF[3*i+k] *EGFF;
	  DcG[3*i+k] = G*D_EGFF[3*i+k] + DG[3*i+k] *EGFF;
	}
    }

  for(i=0;i<M;i++)
    {
      for(k=0;k<3;k++)
	{
	  double t12, t14, t16;
	  t12 = DE[3*i+k]; //diff(E(x,y),x);
	  t14 = DG[3*i+k]; //diff(G(x,y),x);
	  t16 = DF[3*i+k]; //diff(F(x,y),x);
	  
	  for(j=0;j<M;j++)
	    {
	      for(l=0;l<3;l++)
		{
		  double DDE, DDF, DDG;
		  double DDeE, DDeF, DDeG;

		  if(l==k)
		    {
		      DDE = 2.0 * v[0][j]*v[0][i];
		      DDF =       v[1][j]*v[0][i] + 
		   	          v[0][j]*v[1][i];
		      DDG = 2.0 * v[1][j]*v[1][i];

		      DDeE = 2.0*FODD_Km[0][Valence][M*i+j];
		      DDeF = 2.0*FODD_Km[1][Valence][M*i+j];
		      DDeG = 2.0*FODD_Km[2][Valence][M*i+j];
		    }
		  else 
		    {
		      DDE=0.0;
		      DDF=0.0;
		      DDG=0.0;

		      DDeE=0.0;
		      DDeF=0.0;
		      DDeG=0.0;
		    }
		  double t1, t2, t4;
		  t1 = E;
		  t2 = G;
		  t4 = F;

		  double t21, t23, t25, t33, t37, t41;
		  t21 = DE[3*j+l]; //diff(E(x,y),y);
		  t23 = DG[3*j+l]; //diff(G(x,y),y);
		  t25 = DF[3*j+l]; //diff(F(x,y),y);
		  t33 = DDE; //diff(diff(E(x,y),x),y);
		  t37 = DDG; //diff(diff(G(x,y),x),y);
		  t41 = DDF; //diff(diff(F(x,y),x),y);

		  double DD_EGFF;
		  DD_EGFF = 
		    0.75*pow(E*G-F*F,-2.5)*
		    (t12*t2+t1*t14-2.0*t4*t16)*
		    (t21*t2+t1*t23-2.0*t4*t25)-

		    0.5*pow(E*G-F*F,-1.5)*
		    (t33*t2+t12*t23+t21*t14+t1*t37-2.0*t25*t16-2.0*t4*t41);

		  double DDcE, DDcF, DDcG;

		  DDcE = DDE*EGFF+(DE[3*i+k]*D_EGFF[3*j+l]+
				   DE[3*j+l]*D_EGFF[3*i+k])+E*DD_EGFF;
		  DDcF = DDF*EGFF+(DF[3*i+k]*D_EGFF[3*j+l]+
				   DF[3*j+l]*D_EGFF[3*i+k])+F*DD_EGFF;
		  DDcG = DDG*EGFF+(DG[3*i+k]*D_EGFF[3*j+l]+
				   DG[3*j+l]*D_EGFF[3*i+k])+G*DD_EGFF;

		  Hess[3*M*(3*i+k)+(3*j+l)]=(DDcE       *  eE+
					      DcE[3*i+k]* DeE[3*j+l]+
					      DcE[3*j+l]* DeE[3*i+k]+
					       cE       *DDeE
					     )+
		                            (DDcF       *  eF+
					      DcF[3*i+k]* DeF[3*j+l]+
					      DcF[3*j+l]* DeF[3*i+k]+
					       cF       *DDeF
					     )+
		                            (DDcG       *  eG+
					      DcG[3*i+k]* DeG[3*j+l]+
					      DcG[3*j+l]* DeG[3*i+k]+
					       cG       *DDeG
					     );
		}
	    }
	}
    }
  // #ifdef DEBUG
  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {	      
	      for(l=0;l<3;l++)
		{
		  if(fabs(Hess[3*M*(3*i+k)+(3*j+l)])>1.0e9)
		    {
		      cerr << "Warning: Huge derivatives in FirstOrderDataDependentPatch::Hess()"<<endl;
		      exit(1);
		    }

		  if(fabs(Hess[3*M*(3*j+l)+(3*i+k)]-Hess[3*M*(3*i+k)+(3*j+l)])>1e-6) 
		    {
		      cerr << "Hess not symmetric!" << endl;
		      cerr << "i="<<i<<", k="<<k<<", j="<<j<<", l="<<l<<endl;
      		      cerr << Hess[3*M*(3*j+l)+(3*i+k)] << "!=" 
			   << Hess[3*M*(3*i+k)+(3*j+l)] << endl;

		      exit(1);
		    }
		}
	    }
	}
    }
  // #endif
  delete[] DE;
  delete[] DF;
  delete[] DG;

  delete[] D_EG;
  delete[] D_FF;

  delete[] D_EGFF;

  delete[] DeE;
  delete[] DeF;
  delete[] DeG;
  
  delete[] v[0];
  delete[] v[1];
  delete[] v;

#else

  double *K;
  K=new double[M*M];
  Km(NULL, K);

  for(i=0;i<M;i++)
    {
      for(j=0;j<M;j++)
	{
	  for(k=0;k<3;k++)
	    {
	      for(l=0;l<3;l++)
		{
		  Hess[(3*M)*(3*i+k) + 3*j+l] = 0.0;
		}
	    }
	  for(k=0;k<3;k++)
	    {
	      Hess[(3*M)*(3*i+k) + 3*j+k] = 2.0 * K[M*i+j];
	    }
	}
    }
  delete[] K;
#endif

#ifdef DEBUG
  for(i=0;i<3*M;i++)
    {
      for(j=0;j<3*M;j++)
	{
	  if(fabs(Hess[i*3*M+j]-Hess[j*3*M+i])>1e-6)
	    cout <<"Hess "<< i << ", " << j << ", " << Hess[i*3*M+j]
		 <<"!="<< Hess[j*3*M+i] << endl;
	}
    }
#endif
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


