//////////////////////////////////////////////////////////////////////////////
//
// UnitPatch.h, 07/24/01, Ilja Friedel
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef UNITPATCH_USED
#define UNITPATCH_USED

//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <cmath>
#include <stdlib.h>
#include <iostream>
using namespace std;
#include "Patch.h"
#include "ExtraordinaryPatch.h"

//////////////////////////////////////////////////////////////////////////////

class UnitPatch:public Patch
{
 public:
  double Kp_function(const double, const double);
  double Km_function(const double, const double);

  double evaluate_S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      if(s==0)      return(u);
      else if(s==1) return(v);
      else          return(0.0);
    }

  double evaluate_D1S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      if(s==0)      return(1.0);
      else          return(0.0);
    }

  double evaluate_D2S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      if(s==1)      return(1.0);
      else          return(0.0);
    }

  double evaluate_D1D1S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      return(0.0);
    }

  double evaluate_D1D2S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      return(0.0);
    }

  double evaluate_D2D1S(const double u, const double v, const int s) 
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      return(0.0);
    }

  double evaluate_D2D2S(const double u, const double v, const int s)  
    {
      assert(u>=0.0 && u<=1.0);
      assert(v>=0.0 && v<=1.0);
      assert(s>=0 && s<=2);
      return(0.0);
    }
  
//////////////////////////////////////////////////////////////////////////////

  void   print(void) 
    {
      //int i;

      cout << "Unit Patch [0,1)^2" << endl;
    }

//////////////////////////////////////////////////////////////////////////////

  void   Kp(Patch *S, double *K) 
    {
      assert(S&&K);
      cerr << "Error: Kp for UnitPatch not implemented!"<<endl;
      exit(1);
    }

  void   Km(Patch *S, double *K) 
    {
      assert(S&&K);
      cerr << "Error: Km for UnitPatch not implemented!"<<endl;
      exit(1);
    }

//////////////////////////////////////////////////////////////////////////////

  virtual ~UnitPatch();
  //UnitPatch();
};

//////////////////////////////////////////////////////////////////////////////

#endif
