//////////////////////////////////////////////////////////////////////////////
//
// DynamicCompCol_Mat_double3x3.h
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef DynamicCompCol_Mat_double3x3_H
#define DynamicCompCol_Mat_double3x3_H

//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <math.h>

//////////////////////////////////////////////////////////////////////////////
// list of elements

class DCCMdElement3x3
{
 public:

  double val[9];
  int    row;
  DCCMdElement3x3 *next;

  DCCMdElement3x3(DCCMdElement3x3 *DE, int i, double *v);
};

//////////////////////////////////////////////////////////////////////////////

class DynamicCompCol_Mat_double3x3
{
  int dim3_;
  int NumNonZeros_;
  DCCMdElement3x3 **col; // each col sorted list of DCCMdElement

 public:

  //DCCMdElement3x3* find(int i, int j) const;
  DCCMdElement3x3* find3x3(int i, int j) const;

  /*
  double operator() (int i, int j) const
    {
      DCCMdElement3x3 *DE;

      DE=find(i,j);
      if(DE) return(DE->val);
      else   return(0.0);
    }
  */
  //void set(int i, int j, double v);
  //void add(int i, int j, double v);

  void set3x3(int i, int j, double *v);
  void add3x3(int i, int j, double *v);

  //void save(char *fname); 
  //void clear_from_zeros(void);

  //int    *row_ind(void);
  //int    *col_ptr(void);
  //double *val(void);

  //int dim(void) {return dim_;}
  //int NumNonZeros(){return NumNonZeros_;}

  void mult(double *x, double *result);
  //void Cholesky(void);

  ~DynamicCompCol_Mat_double3x3();
  DynamicCompCol_Mat_double3x3(int d3);
};

//////////////////////////////////////////////////////////////////////////////

#endif


