//////////////////////////////////////////////////////////////////////////////
//
// ExtraordinaryPatch.h, 07/24/01, Ilja Friedel
//
//////////////////////////////////////////////////////////////////////////////

#ifndef EXTRAORDINARYPATCH_USED
#define EXTRAORDINARYPATCH_USED

//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <cmath>
#include <stdlib.h>
#include <iostream>
using namespace std;
#include "Patch.h"
#include "BicubicPatch.h"
#include "EigenStructure.h"

//////////////////////////////////////////////////////////////////////////////

class ExtraordinaryPatch:public Patch
{
 public:

  double Kp_function(const double, const double);
  double Km_function(const double, const double);
  void   add_sample_to_Kp(double u, double v, double weight, double *K);
  void   add_sample_to_Km(double u, double v, double weight, double *K);

  int    M;
  int    Valence;
  double *control_points[3];
  Patch  *ReferenceS;
  int    IL_i, IL_j;
  EigenStructure *ES;

  double evaluate_S(const double u, const double v, const int s);

  double evaluate_D1S(const double u, const double v, const int s);
  double evaluate_D2S(const double u, const double v, const int s);

  double evaluate_D1D1S(const double u, const double v, const int s);
  double evaluate_D1D2S(const double u, const double v, const int s);
  double evaluate_D2D1S(const double u, const double v, const int s);
  double evaluate_D2D2S(const double u, const double v, const int s);
  
//////////////////////////////////////////////////////////////////////////////

  virtual double KpEnergy(void);
  //  virtual double grad_KpEnergy(int coord, int i);

//////////////////////////////////////////////////////////////////////////////

  void   print(void);
  void   export_IV(const char *fn, double r, double g, double b);
  void   Kp(Patch *S, double *K);
  void   Km(Patch *S, double *K);

//////////////////////////////////////////////////////////////////////////////

  virtual ~ExtraordinaryPatch();
  ExtraordinaryPatch(double **data, int N);
};

//////////////////////////////////////////////////////////////////////////////

#endif
