//////////////////////////////////////////////////////////////////////////
//
// PriorityQueue.cpp, Ilja Friedel, 07/16/02
//
//////////////////////////////////////////////////////////////////////////

#include "PriorityQueue.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

PriorityQueue::~PriorityQueue()
{

}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

LogPQueue::~LogPQueue()
{
}

//////////////////////////////////////////////////////////////////////////
// ok
LogPQueue::LogPQueue(int s, double max_v, double min_v)
{
  int i;

  assert(s>1 && s<=100000);
  assert(min_v>0.0);
  assert(max_v>min_v);
  
  table_size = s;
  max_val    = max_v;
  min_val    = min_v;
  lcq = log(max_val)/table_size;

  N     = 0;
  topp  = 0;

  table=new Set*[table_size];
  assert(table);

  for(i=0;i<table_size;i++) table[i]=NULL;
}

//////////////////////////////////////////////////////////////////////////
// ok

int LogPQueue::size(void)
{
  return(N);
}

//////////////////////////////////////////////////////////////////////////

void LogPQueue::push(double priority, Priority *P)
{
  int n;

  assert(priority>0);
  assert(P->PQid==NULL);
  assert(priority>=min_val);
  assert(priority<=max_val);

  n=(int)floor(log(priority)/lcq);
  assert(0<=n && n<table_size);

  if(!table[n])
    {
      table[n]=new Set();
    }
  
  P->priority=priority;
  P->PQid=table[n]->insert(P);
  if(n>topp) topp=n;

  N++;
}

//////////////////////////////////////////////////////////////////////////

void LogPQueue::update_priority(double priority, Priority *P)
{
  assert(priority>0);
  assert(P->PQid!=NULL);
  assert(priority>=min_val);
  assert(priority<=max_val);

  if(
}

//////////////////////////////////////////////////////////////////////////

void LogPQueue::remove(Priority *P)
{
  assert(N>0);
  assert(P->PQid!=NULL);

  N--;
}

//////////////////////////////////////////////////////////////////////////

Priority* LogPQueue::top(void)
{
  assert(N>0);
  assert(table[topp]);

  return(table[topp]->Element());
}

//////////////////////////////////////////////////////////////////////////

void LogPQueue::pop(void)
{
  assert(N>0);
  assert(table[topp]);

  table[topp]->removeElement();
  N--;
  if(N!=0)
    {
      while(table[topp]->empty()) topp--;
    }
}

//////////////////////////////////////////////////////////////////////////

bool LogPQueue::empty(void)
{
  assert(N>=0);
  return(N==0);
}
		       
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
