//////////////////////////////////////////////////////////////////////////
//
// RingList.h, Ilja Friedel, 08/31/02
//
//////////////////////////////////////////////////////////////////////////

#ifndef RINGLIST_DEF
#define RINGLIST_DEF 1

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class Priority
{
  double priority;
  void*  PQid;

 public:

  bool   is_in_queue(void){return(PQid!=NULL);}

  Priority()
    {
      PQid       = NULL;
      priority   = 0.0;
    }
};

//////////////////////////////////////////////////////////////////////////

class TreeNode
{
  Priority *data;
  Node     *next;
  Node     *prev;
  Node     *parent;
  Node     *lchild;
  Node     *rchild;

  int      degree(void);

 public:

  TreeNode()
    {
      data  =NULL;
      next  =NULL;
      prev  =NULL;
      parent=NULL;
      lchild=NULL;
      rchild=NULL;
    }
};

class Tree
{
  friend class Priority;
  friend class TreeNode;

  TreeNode *root;

 public:
  
  insert(Priority *);
  //insert_before(TreeNode *, Priority *);
  insert_after(TreeNode *, Priority *);
  insert_child(TreeNode *, Priority *);
  //insert_lchild(TreeNode *, Priority *);
  //insert_rchild(TreeNode *, Priority *);
  //insert_parent(TreeNode *, Priority *);

  void remove(Priority *);

  TreeNode* FirstElement(void);
  TreeNode* NextElement(TreeNode *);
  
};

//////////////////////////////////////////////////////////////////////////
/*
class RingListElement
{

  void       *data;
  SetElement *next;
  SetElement *prev;

 public:

  SetElement(void *O, SetElement *n=NULL)
    {
      data=O;
      next=n;
    }
};

//////////////////////////////////////////////////////////////////////////

class RingList
{
  SetElement  *ptr;
  int         NumElements_;

  friend class SetElement;

 public:

  // general set operations, no side effects
  void        remove(SetElement* ptr); 
  SetElement* insert(void* O);   
  int         ElementOf(void* O);
  void*       Element(void);     
  void        print(void);       
  int         NumElements(void)          
    {
      return(NumElements_);
    }
  
  // special FIFO set operations with side effects
  void        nextElement(void);  // changes Element
  void        removeElement(void);// removes this Element     
  int         find(void* O);      // sets element to O if found
  
  virtual     ~Set();
              Set();
              Set(Set *S); // copy constructor
};
*/
}
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#endif
